

--Load the xml assemply
dotNet.loadAssembly "system.xml" 
--Create an xml document object.
xmlDoc=dotNetObject "system.xml.xmlDocument"

--Open the file in Max to see the file. 
saveFile =  getSavePath caption:"Select folder" initialDir:(getDir #export)
xmlPath= (saveFile+"\\savetocollada.dae")


fn getmatFile inst_mat_targ ele = (
	
	curNode = ele.GetElementsByTagname "library_materials" --make curnode the node that is named library_materials
	
	 curNode = ((curNode.Item[0].ChildNodes).Item[0])--make curnode the first item in the array that was returned
	 if(inst_mat_targ != undefined) then( --checks if the target material was set
	 matId= filterString inst_mat_targ "#"
	 )
	 if(curNode!= undefined) then( --checks if the nodes under library_materials exist
     if((curNode.GetAttributeNode "id").value == matId[1]) then (--checks if the id of the material tag matches the id passed in
	    curNode = ((curNode.ChildNodes).Item[0])--makes curnode equal to its first child
		inst_effect_url = (curNode.GetAttributeNode "url").value --gets the url of the instance effect node
		curNode = ele.GetElementsByTagname "library_effects"--makes curnode the node that is named library_effects
		curNode = ((curNode.Item[0].ChildNodes).Item[0])--makes curnode the first item in the array that was returned
		effectId= filterString inst_effect_url "#"--filters the url to remove the # so it can be matched with the effect if of the effect tag
		if((curNode.GetAttributeNode "id").value == effectId[1]) then ( --checks if the id of the effect tag matches effectId
		   while (curNode.ChildNodes).Item[0] != undefined do --loops while curnode has childnodes
 	(
		
		curNode = (curNode.ChildNodes).Item[0]--makes curnode equal to its first child
		if((curNode.ChildNodes).Item[0] == undefined and curNode.NextSibling != undefined) then (--checks if there are no child nodes if the node has a sibling and makes curnod equal to that sibling
		   curNode = curNode.NextSibling
	)
		
		if(curNode.Name == "texture") then (--checks if the name of the current node is equal to texture and then sets image_map_id to the nodes value
			image_map_id = (curNode.GetAttributeNode "texture").value
		)
		
		
		)
		if(image_map_id != undefined) then (--checks if image_map_id has been set
			curNode = ele.GetElementsByTagname "library_images"--makes curnode equal to the node named library_images
	 curNode = ((curNode.Item[0].ChildNodes).Item[0])--makes curnode equal to the first element in the array returned
	    if((curNode.GetAttributeNode "id").value == image_map_id) then (--checks if the id of the image node is equal to image_map_id
	        curNode = ((curNode.ChildNodes).Item[0])--makes curnode equal to curnodes first child
			image_file = curNode.InnerText--makes image_file equal to the text within curnode
        )
		if(image_file != "noFile") then(--checks if image_file is equal to nofile
		image_file = substring image_file 8 300 --removes the file\\ from the front of the file name
		)
		)
	)
)
)
		return image_file
 
	 
	
)

fn buildObject ele parent:undefined=
(
	
	curNode = ele.GetElementsByTagname "library_visual_scenes"--makes curnode equal to the node named library_visual_scenes
	
	 curNode = curNode.Item[0]--makes curnode equal to the first element in the array returned

	while (curNode.ChildNodes).Item[0] != undefined do --loops while curnode has children
 	(
		curNode = (curNode.ChildNodes).Item[0]--makes curnode equal to its first child 
		if((curNode.ChildNodes).Item[0] == undefined and curNode.NextSibling != undefined) then (--checks if curnode has children and siblings and if it has a sibling makes curnode equal to it
		   curNode = curNode.NextSibling
	)
		
		if(curNode.Name == "node") then (--checks if curnode's name is equal to node and if it is it sets object name to its name value
			objName = (curNode.GetAttributeNode "name").value
			
		)
		 if(curNode.Name == "translate") then (--checks if curnode's name is equal to translate and if it is it sets translation to the text of curnode and sets curnode to its next sibling
			  translation = curNode.InnerText
			  curNode = curNode.NextSibling
		)
		if(curNode.Name == "rotate") then (--checks if curnode's name is equal to rotate and if it is it sets rotateval to the text of curnode and sets curnode to its next sibling
			  rotateval = curNode.InnerText
			 curNode = curNode.NextSibling
			
		)
		if(curNode.Name == "instance_geometry")then (--checks if curnodes name is equal to instance_geometry and if it is retrives the url from the tag
			  inst_geo_url = (curNode.GetAttributeNode "url").value
		)
		if(curNode.Name == "instance_material") then (--checks if curnodes name is equal to instance_geometry and if it is retrives the target from the tag
			  inst_mat_targ = (curNode.GetAttributeNode "target").value
			
		)
		
		
		)
	 if(inst_mat_targ != undefined) then (--if inst_mat_targ then get the filename of the image and store it in image_file
		 image_file =  getMatFile inst_mat_targ ele
	 )
	 if(inst_geo_url != undefined) then (--if inst_geo_url then start getting the mesh information and build the mesh
		curNode = ele.GetElementsByTagname "library_geometries"--sets curnode to the library geometries tag
	
	 curNode = ((curNode.Item[0].ChildNodes).Item[0])--sets curnode to the first element in the array that was returned
		  geoId= filterString inst_geo_url "#"--removes the # from the uro and stores it in geoID
     if((curNode.GetAttributeNode "id").value == geoId[1]) then (--if the geoid matches the id of the geometry tag do the following
		 while (curNode.ChildNodes).Item[0] != undefined do --do the below while curnode has children
 	(
		if(curNode.Name != "source") then ( --if the tag name is source name curnode equal to its child node
		curNode = (curNode.ChildNodes).Item[0]
		)
		--showmethods curNode
		if((curNode.ChildNodes).Item[0] == undefined and curNode.NextSibling != undefined) then (
		   curNode = curNode.NextSibling
	)
		if(curNode.Name == "source") then (--if the node name is source then put the id value of the node into geoid and append -array to it
			geoId = ((curNode.GetAttributeNode "id").value)+"-array"
			curNode = (curNode.ChildNodes).Item[0]--make curnode equal to its first child
			if((curNode.ChildNodes).Item[0] == undefined and curNode.NextSibling != undefined) then (
		   curNode = curNode.NextSibling
	)
			
		)
		if((curNode.Name == "float_array")) then (--check if the name of curnode is float_array
		 if((curNode.GetAttributeNode "id").value == geoId)then (
			  if((matchPattern geoId pattern:"*Position*") == true) then (--checks if the word position is inside geoId 
		        vert_float_count =   (curNode.GetAttributeNode "count").value --gets the count of the vertex float array
			   
		        vert_float_string =  curNode.InnerText -- gets the string with the vertex values and stores it
		         curNode = curNode.NextSibling --makes curnode equal to its next sibling
			     geoId = "#" + geoId --adds a # to geoid
	)
			  if((matchPattern geoId pattern:"*Normal0*") == true) then (--checks if the word normal0 is inside geoid
		        norm_float_count =   (curNode.GetAttributeNode "count").value--gets the count of the normal float array
			   
		        norm_float_string =  curNode.InnerText -- gets the string with the normal values and stores it
		         curNode = curNode.NextSibling --makes curnode equal to its next sibling
			     geoId = "#" + geoId
	)
	
	           if((matchPattern geoId pattern:"*UV0*") == true) then (--checks if the word UV0 is inside geoid
		        UV_float_count =   (curNode.GetAttributeNode "count").value --gets the count of the UV float array
			   
		        UV_float_string =  curNode.InnerText-- gets the string with the UV values and stores it
		         curNode = curNode.NextSibling
			     geoId = "#" + geoId
	)
		)
		
	)
	    if((curNode.Name == "accessor")) then (
			if((curNode.GetAttributeNode "source").value == geoId) then (
			if((matchPattern geoId pattern:"*Position*") == true) then (
			   vert_vec_count = (curNode.GetAttributeNode "count").value --gets the number of vertex vectors
			vert_vec_size = (curNode.GetAttributeNode "stride").value --gets the stride of the vertex vectors
			curNode = curNode.ParentNode --goes back up 2 levels and goes to the next sibling
			curNode = curNode.ParentNode
			curNode = curNode.NextSibling
		)
		     if((matchPattern geoId pattern:"*Normal0*") == true) then (
		        norm_vec_count = (curNode.GetAttributeNode "count").value --gets the number of normal vectors
			norm_vec_size = (curNode.GetAttributeNode "stride").value --gets the stride of the normal vectors
		    curNode = curNode.ParentNode --goes back up 2 levels and goes to the next sibling
			curNode = curNode.ParentNode
			curNode = curNode.NextSibling
	)  
	        if((matchPattern geoId pattern:"*UV0*") == true) then (
		        UV_vec_count = (curNode.GetAttributeNode "count").value --gets the number of the UV vectos
			UV_vec_size = (curNode.GetAttributeNode "stride").value --gets the stride of the UV vectors
			curNode = curNode.ParentNode --goes back up 2 levels and goes to the next sibling
			curNode = curNode.ParentNode
			curNode = curNode.NextSibling
	        curNode = curNode.NextSibling
	)
	if(curNode.Name == "triangles") then (
	    tri_count = (curNode.GetAttributeNode "count").value --gets the number of triangles
		curNode = (curNode.ChildNodes).Item[0] --makes curnode equal to its first child and then goes down 3 siblings in the tree 
		curNode = curNode.NextSibling
		curNode = curNode.NextSibling
		curNode = curNode.NextSibling
		face_string = curNode.InnerText --puts the primitive values into the face string variable
	)
			
		)
		)
	
		)
	 )
	 vert_array = #() --array to hold the verts to build the mesh
	 norm_array = #() --array to hold the normals for the mesh
	 UV_array = #() --array to hold the uvs for the mesh
	 face_array = #() --array to hold the faces for the mesh
	 tface_array = #() --array to hold the texture faces for the mesh
	 vert_vec_string = filterString vert_float_string "\n" --filters the strings so that each element holds a vector
	 norm_vec_string = filterString norm_float_string "\n" 
	 UV_vec_string = filterString UV_float_string "\n" 	 
	 vert_vec_string = filterString vert_float_string " , \n" --filters the strings so each element holds a float 
	 norm_vec_string = filterString norm_float_string " , \n"
	 UV_vec_string = filterString UV_float_string " , \n"
	 face_string = filterString face_string " , \n" --filters the faces so each element holds an int
	 vert_vec_count = (vert_vec_count as integer)

	 if((vert_vec_size as integer) == 3) then (--checks if the stride is equal to 3
		 for i = 1 to (vert_vec_count*3) by 3  do (--goes through the array for 3 times the number of the count of vectors and increases i by 3 each iteration
			 temp_array = [(vert_vec_string[i] as float), (vert_vec_string[i+1] as float), (vert_vec_string[i+2] as float)] --makes temp array a vector of vertex values
	 append vert_array temp_array --appends the vertex to the array
			
		 )
	 )
	 norm_vec_count = (norm_vec_count as integer)
	 if((norm_vec_size as integer) == 3) then (
		 for i = 1 to (norm_vec_count*3) by 3  do (--goes through the array for 3 times the number of the count of vectors and increases i by 3 each iteration
			 temp_array = [(norm_vec_string[i] as float), (norm_vec_string[i+1] as float), (norm_vec_string[i+2] as float)] --makes temp array a vector of normal values
	 append norm_array temp_array --appends the normal to the array
			
		 )
	 )
	 UV_vec_count = (UV_vec_count as integer)
	 if((UV_vec_size as integer) == 2) then (
		 for i = 1 to UV_vec_string.count by 2  do (--goes through the array for the number of elements in it  and increases i by 2 each iteration
			temp_array = [(UV_vec_string[i] as float), (UV_vec_string[i+1] as float), 0] --makes temp array equal to a vector of UV values
	 append UV_array temp_array --appends the UV to the array
			
		 )
	 )
	 faceInd = #() --array of face indicies
	 normInd = #() --array of normal indicies
	 tfaceInd = #() --array of texture face indicies
	  tri_count = (tri_count as integer)
	  for i = 1 to ((tri_count*3)*3) by 3  do ( --goes through the loop for 3* 3* the number of triangles 
		append	 faceInd (face_string[i] as integer) --appends the face value
	    append normInd (face_string[i+1] as integer) --appends the normal value
	    append tfaceInd (face_string[i+2] as integer) --appends the texture face value
		 )
		
		 for i = 1 to (tri_count*3) by 3  do ( --goes through the loop for 3 times the number of triangles
		append	 face_array [((faceInd[i] as integer))+1,((faceInd[i+1] as integer)+1),((faceInd[i+2] as integer)+1)] --appends an array of face indicies
	    append	 tface_array [((tfaceInd[i] as integer)+1),((tfaceInd[i+1] as integer)+1),((tfaceInd[i+2] as integer)+1)] --appends an array of face indicies
			
		 )
		
	new_mesh = mesh vertices:vert_array faces:face_array --creates the mesh
	setNumTVerts new_mesh UV_vec_count
		 for i = 1 to  UV_array.count do(
					setTVert new_mesh i UV_array[i] --set texture vertice ID- to 3point array
				)
     buildTVFaces new_mesh --enable texture faces arrays
				for i = 1 to tri_count do(
					setTVFace new_mesh i tface_array[i]
				)
	    for f = 1 to tri_count do

         (
        setFaceNormal new_mesh f norm_array[f]
		 )
		 if(image_file != undefined) then(--if images file exists create the bitmap and material and assign it to new_mesh
		 m = standard()
		 bt = BitmapTexture()
         bt.filename = image_file
         m.diffuseMap = bt
		 m.showInViewport = true
 		 new_mesh.material = m
		 )
		
	update new_mesh
	 )
	 
	
)

--If the file exists then load it.
if doesFileExist xmlPath then
(
	--Load the XML file.
	xmlDoc.load xmlPath
	--Check to make sure the xmlDoc has a root element. 
	docEle=xmlDoc.documentElement
	
	--If the root element exists continue. 
	if docEle!=undefined and docEle.name=="COLLADA" then
	(
		--traverse the XML tree.
		buildObject docEle
	)
)



